
#undef TRACEPOINT_PROVIDER
#define TRACEPOINT_PROVIDER ubuntu_app_launch

#undef TRACEPOINT_INCLUDE
#define TRACEPOINT_INCLUDE "./ubuntu-app-launch-trace.h"

#if !defined(UBUNTU_APP_LAUNCH_TRACE_H) || defined(TRACEPOINT_HEADER_MULTI_READ)
#define UBUNTU_APP_LAUNCH_TRACE_H

#include <lttng/tracepoint.h>


#include <endian.h>
#define BYTE_ORDER __BYTE_ORDER

/*******************************
  LibUAL start function
 *******************************/
TRACEPOINT_EVENT(ubuntu_app_launch, libual_start,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, libual_determine_type,
	TP_ARGS(const char *, appid, const char *, type),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(type, type)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, libual_determine_libertine,
	TP_ARGS(const char *, appid, const char *, executionenv),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(executionenv, executionenv)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, libual_job_path_determined,
	TP_ARGS(const char *, appid, const char *, job_path),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(job_path, job_path)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, libual_start_message_sent,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, libual_start_message_callback,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)

/*******************************
  LibUAL observers
 *******************************/

TRACEPOINT_EVENT(ubuntu_app_launch, observer_start,
	TP_ARGS(const char *, type),
	TP_FIELDS(
		ctf_string(type, type)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, observer_finish,
	TP_ARGS(const char *, type),
	TP_FIELDS(
		ctf_string(type, type)
	)
)


/*******************************
  Second Exec tracking
 *******************************/
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_start,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_emit_resume,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_resume_complete,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_resume_timeout,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_emit_focus,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_finish,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_got_dbus_names,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_got_primary_pid,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_request_pid,
	TP_ARGS(const char *, appid, const char *, dbus_name),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(dbus_name, dbus_name)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_got_pid,
	TP_ARGS(const char *, appid, const char *, dbus_name),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(dbus_name, dbus_name)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_contact_app,
	TP_ARGS(const char *, appid, const char *, dbus_name),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(dbus_name, dbus_name)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_app_contacted,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_app_error,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, second_exec_connection_complete,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)

/*******************************
  Desktop File Single Instance
 *******************************/
TRACEPOINT_EVENT(ubuntu_app_launch, desktop_single_start,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, desktop_single_found,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, desktop_single_finished,
	TP_ARGS(const char *, appid, const char *, apptype),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_string(apptype, apptype)
	)
)

/*******************************
  CGroup Manager PID listing
 *******************************/
TRACEPOINT_EVENT(ubuntu_app_launch, pids_list_start,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, pids_list_connected,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, pids_list_finished,
	TP_ARGS(const char *, appid, int, numpids),
	TP_FIELDS(
		ctf_string(appid, appid)
		ctf_integer(int, numpids, numpids)
	)
)

/*******************************
  Click Exec
 *******************************/

TRACEPOINT_EVENT(ubuntu_app_launch, click_start,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, click_starting_sent,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, click_found_pkgdir,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, click_configured_env,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, click_read_manifest,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, click_read_desktop,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, click_send_env_vars,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, handshake_wait,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, handshake_complete,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)

/*******************************
  Desktop Exec
 *******************************/

TRACEPOINT_EVENT(ubuntu_app_launch, desktop_start,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, desktop_starting_sent,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, desktop_found,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)
TRACEPOINT_EVENT(ubuntu_app_launch, desktop_send_env_vars,
	TP_ARGS(const char *, appid),
	TP_FIELDS(
		ctf_string(appid, appid)
	)
)


#endif /* UBUNTU_APP_LAUNCH_TRACE_H */

#include <lttng/tracepoint-event.h>
